diff --git a/debian/doomsday-compat b/debian/doomsday-compat
index 998c81d..23ee96f 100755
--- a/debian/doomsday-compat
+++ b/debian/doomsday-compat
@@ -69,6 +69,21 @@ do
 	cmdline="$cmdline $arg"
 done
 
+# if no -iwad parameter is given, guess from executable name
+if [ -z "$iwadfile" ]
+then
+	case "$(basename $0)" in
+		heretic)
+			iwadfile=heretic.wad
+			iwadpath=$iwaddir/$iwadfile
+			;;
+		hexen)
+			iwadfile=hexen.wad
+			iwadpath=$iwaddir/$iwadfile
+			;;
+	esac
+fi
+
 case "$(echo $iwadfile | tr '[:upper:]' '[:lower:]')" in
 	doom1.wad)
 		gamemode=doom1-share
@@ -138,12 +153,23 @@ case "$(echo $pwadfile | tr '[:upper:]' '[:lower:]')" in
 		;;
 esac
 
+# fall back to alternatives
 if [ $gamemode = "doom2" \
      -a ! -f $iwaddir/doom2.wad \
      -a ! -f $iwaddir/doom2f.wad \
      -a -f $iwaddir/freedoom2.wad ]
 then
 	gamemode=freedoom2
+elif [ \( $gamemode = "heretic" -o $gamemode = "heretic-ext" \) \
+     -a ! -f $iwaddir/heretic.wad \
+     -a -f $iwaddir/heretic1.wad ]
+then
+	gamemode=heretic-share
+elif [ $gamemode = "hexen" \
+     -a ! -f $iwaddir/hexen.wad \
+     -a -f $iwaddir/hexendemo.wad ]
+then
+	gamemode=hexen-demo
 fi
 
 if [ -n "$pwadpath" ]
